import React from 'react';
import { areEqual } from 'react-window';
import { optionClassName } from '../utils';
const Option = React.memo(({ index, style, data: { menuOptions, selectOption, renderOptionLabel, focusedOptionIndex } }) => {
    const { data, value, label, isDisabled, isSelected } = menuOptions[index];
    const className = optionClassName(isDisabled, isSelected, (index === focusedOptionIndex));
    const onClickHandler = !isDisabled
        ? (() => selectOption({ data, value, label }, isSelected))
        : undefined;
    return (React.createElement("div", { style: style, className: className, onClick: onClickHandler }, renderOptionLabel(data)));
}, areEqual);
Option.displayName = 'Option';
export default Option;
